<?php
/* History Tab COMPONENT */
/* Copyright 2015-11-03 Troy Lea aka Box293 */

require_once(dirname(__FILE__).'/../../common.inc.php');

// initialization stuff
pre_init();
// start session
init_session();
// grab GET or POST variables 
grab_request_vars();
// check prereqs
check_prereqs();
// check authentication
check_authentication(false);


$html = '';
		
/* Get the object_id passed to us */
$object_id = grab_request_var('object_id',false);
//print_r($object_id);

/* Get the number_items passed to us */
$number_items = grab_request_var('number_items',false);
//print_r($number_items);


/* Global array of DB tables */
global $db_tables;


/* Define the History Array we will store all data in */
$history_array = array();


/* Get Acknowledgements */
$statement_acknowledgements = 'SELECT * FROM ' .$db_tables[DB_NDOUTILS]['acknowledgements']. ' WHERE object_id=' .$object_id. ' ORDER BY entry_time DESC LIMIT 0,' . $number_items;
$acknowledgements = exec_sql_query(DB_NDOUTILS,$statement_acknowledgements,false);
//print_r('$acknowledgements: ' . $acknowledgements . "<br/><br/><br/>");


/* Get Comments */
$args_nagios_comments = array(
	'cmd'		=> 'getcomments',
	'object_id' => $object_id,
	); /* End $args_nagios_comments = array( */
$xml_nagios_comments = get_backend_xml_data($args_nagios_comments);   
//print_r('$xml_nagios_comments: ' . $xml_nagios_comments . "<br/><br/><br/>");


/* Get Comment History */
$statement_commenthistory = 'SELECT * FROM ' .$db_tables[DB_NDOUTILS]['commenthistory']. ' WHERE object_id=' .$object_id. ' ORDER BY entry_time DESC LIMIT 0,' . $number_items;
$commenthistory = exec_sql_query(DB_NDOUTILS,$statement_commenthistory,false);
//print_r('$commenthistory: ' . $commenthistory . "<br/><br/><br/>");


/* Get Scheduled Downtime Comments */
$statement_scheduleddowntimecomments = 'SELECT * FROM ' .$db_tables[DB_NDOUTILS]['scheduleddowntime']. ' WHERE object_id=' .$object_id. ' ORDER BY entry_time DESC LIMIT 0,' . $number_items;
$scheduleddowntimecomments = exec_sql_query(DB_NDOUTILS,$statement_scheduleddowntimecomments,false);
//print_r('$scheduleddowntimecomments: ' . $scheduleddowntimecomments . "<br/><br/><br/>");


/* Get Downtime History */
$statement_downtimehistory = 'SELECT * FROM ' .$db_tables[DB_NDOUTILS]['downtimehistory']. ' WHERE object_id=' .$object_id. ' ORDER BY entry_time DESC LIMIT 0,' . $number_items;
$downtimehistory = exec_sql_query(DB_NDOUTILS,$statement_downtimehistory,false);
//print_r('$downtimehistory: ' . $downtimehistory . "<br/><br/><br/>");


/* Get External Commands */
$statement_externalcommands = 'SELECT * FROM ' .$db_tables[DB_NDOUTILS]['externalcommands']. ' WHERE command_name=\'DISABLE_HOST_EVENT_HANDLER\' OR command_name=\'DISABLE_SVC_EVENT_HANDLER\' OR command_name=\'ENABLE_HOST_EVENT_HANDLER\' OR command_name=\'ENABLE_SVC_EVENT_HANDLER\' OR command_name=\'DISABLE_HOST_FLAP_DETECTION\' OR command_name=\'DISABLE_SVC_FLAP_DETECTION\' OR command_name=\'ENABLE_HOST_FLAP_DETECTION\' OR command_name=\'ENABLE_SVC_FLAP_DETECTION\' OR command_name=\'DISABLE_HOST_CHECK\' OR command_name=\'DISABLE_SVC_CHECK\' OR command_name=\'ENABLE_HOST_CHECK\' OR command_name=\'ENABLE_SVC_CHECK\' OR command_name=\'DISABLE_HOST_NOTIFICATIONS\' OR command_name=\'DISABLE_SVC_NOTIFICATIONS\' OR command_name=\'ENABLE_HOST_NOTIFICATIONS\' OR command_name=\'ENABLE_SVC_NOTIFICATIONS\' OR command_name=\'DISABLE_PASSIVE_HOST_CHECKS\' OR command_name=\'DISABLE_PASSIVE_SVC_CHECKS\' OR command_name=\'ENABLE_PASSIVE_HOST_CHECKS\' OR command_name=\'ENABLE_PASSIVE_SVC_CHECKS\' OR command_name=\'START_OBSESSING_OVER_HOST\' OR command_name=\'START_OBSESSING_OVER_SVC\' OR command_name=\'STOP_OBSESSING_OVER_HOST\' OR command_name=\'STOP_OBSESSING_OVER_SVC\' ORDER BY entry_time DESC LIMIT 0,' . $number_items;
$externalcommands = exec_sql_query(DB_NDOUTILS,$statement_externalcommands,false);
//print_r('$externalcommands: ' . $externalcommands . "<br/><br/><br/>");


/* Get Object */
$statement_currentobject = 'SELECT * FROM ' .$db_tables[DB_NDOUTILS]['objects']. ' WHERE object_id=' .$object_id. ' AND is_active=1';
$currentobject = exec_sql_query(DB_NDOUTILS,$statement_currentobject,false);
//print_r('$currentobject: ' . $currentobject . "<br/><br/><br/>");
foreach ($currentobject as $currentobject_row) {
	$currentobject_name1 = $currentobject_row['name1'];
	$currentobject_name2 = $currentobject_row['name2'];
	} /* End foreach ($currentobject as $currentobject_row) { */
//print_r('$currentobject_name1: ' . $currentobject_name1 . "<br/><br/><br/>");
//print_r('$currentobject_name2: ' . $currentobject_name2 . "<br/><br/><br/>");


/* Now scan each table for any item that belongs to this service / host */
foreach ($acknowledgements as $acknowledgements_row) {
	$history_array[] = array(
		'acknowledgement_id' 	=> $acknowledgements_row['acknowledgement_id'],
		'entry_time' 			=> $acknowledgements_row['entry_time'],
		'comment_data' 			=> $acknowledgements_row['comment_data'],
		'state' 				=> $acknowledgements_row['state'],
		'author_name' 			=> $acknowledgements_row['author_name'],
		'type' 					=> 'Acknowledgement',
		); /* End $history_array[] = array( */
	} /* End foreach ($acknowledgements as $acknowledgements_row) { */


foreach($xml_nagios_comments as $comment => $value) {
	//print_r('$comment: ' . $comment . ' === ' . '$value: ' . $value . "<br/><br/><br/>");
	$c_test = 1;
	if ($comment == 'comment') {
		/* Does the object already exist in the History array */
		foreach ($history_array as $history_array_key => $history_array_value) {
			if ($value->entry_time == $history_array[$history_array_key]['entry_time']) {
				$c_test = 2;
				} /* End if ($value->entry_time == $history_array[$history_array_key]['entry_time']) { */
			} /* End foreach ($history_array as $history_array_key => $history_array_value) { */

		/* If the object does not exist then add it to the History array */
		if ($c_test == 1) {
			$history_array[] = array(
				'comment_id' 	=> $value->comment_id,
				'entry_time' 	=> $value->entry_time,
				'comment_data' 	=> $value->comment_data,
				'author_name' 	=> $value->author_name,
				'type' 			=> 'Comment',
				); /* End $history_array[] = array( */
			} /* End if ($c_test == 1) { */
		} /* End if ($comment == 'comment') { */
	} /* End foreach($xml_nagios_comments as $comment => $value) { */


foreach ($commenthistory as $commenthistory_row) {
	$ch_test = 1;
	/* Does the object already exist in the History array */
	foreach ($history_array as $history_array_key => $history_array_value) {
		if ($commenthistory_row['entry_time'] == $history_array[$history_array_key]['entry_time']) {
			$ch_test = 2;
			} /* End if ($commenthistory_row['entry_time'] == $history_array[$history_array_key]['entry_time']) { */
		if ($commenthistory_row['comment_data'] == $history_array[$history_array_key]['comment_data']) {
			$ch_test = 2;
			} /* End if ($commenthistory_row['comment_data'] == $history_array[$history_array_key]['comment_data']) { */
		} /* End foreach ($history_array as $history_array_key => $history_array_value) { */

	/* If the object does not exist then add it to the History array */
	if ($ch_test == 1) {
		$history_array[] = array(
			'commenthistory_id'	=> $commenthistory_row['commenthistory_id'],
			'entry_time' 		=> $commenthistory_row['entry_time'],
			'comment_data' 		=> $commenthistory_row['comment_data'],
			'author_name' 		=> $commenthistory_row['author_name'],
			'type' 				=> 'Comment History',
			); /* End $history_array[] = array( */
		} /* End if ($ch_test == 1) { */
	} /* End foreach ($commenthistory as $commenthistory_row) { */


foreach ($scheduleddowntimecomments as $scheduleddowntimecomments_row) {
	$history_array[] = array(
		'commenthistory_id'	=> $scheduleddowntimecomments_row['scheduleddowntime_id'],
		'entry_time' 		=> $scheduleddowntimecomments_row['entry_time'],
		'comment_data' 		=> '\''. $scheduleddowntimecomments_row['comment_data'] . '\' is the comment for the downtime scheduled from ' . $scheduleddowntimecomments_row['scheduled_start_time'] . ' to ' . $scheduleddowntimecomments_row['scheduled_end_time'],
		'author_name' 		=> $scheduleddowntimecomments_row['author_name'],
		'type' 				=> 'Scheduled Downtime Comment',
		); /* End $history_array[] = array( */
	} /* End foreach ($scheduleddowntimecomments as $scheduleddowntimecomments_row) { */


foreach ($downtimehistory as $downtimehistory_row) {
	$dh_test = 1;
	/* Does the object already exist in the History array */
	foreach ($history_array as $history_array_key => $history_array_value) {
		if ($history_array[$history_array_key]['type'] == 'Scheduled Downtime Comment') {
			if ($downtimehistory_row['entry_time'] == $history_array[$history_array_key]['entry_time']) {
				$dh_test = 2;
				} /* End if ($downtimehistory_row['entry_time'] == $history_array[$history_array_key]['entry_time']) { */
			} /* End if ($history_array[$history_array_key]['type'] == 'Scheduled Downtime Comment') { */
		} /* End foreach ($history_array as $history_array_key => $history_array_value) { */

	/* If the object does not exist then add it to the History array */
	if ($dh_test == 1) {
		$history_array[] = array(
			'commenthistory_id'	=> $downtimehistory_row['downtimehistory_id'],
			'entry_time' 		=> $downtimehistory_row['entry_time'],
			'comment_data' 		=> '\''. $downtimehistory_row['comment_data'] . '\' is the comment for the downtime scheduled from ' . $downtimehistory_row['scheduled_start_time'] . ' to ' . $downtimehistory_row['scheduled_end_time'],
			'author_name' 		=> $downtimehistory_row['author_name'],
			'type' 				=> 'Scheduled Downtime Comment History',
			); /* End $history_array[] = array( */
		} /* End if ($dh_test == 1) { */
	} /* End foreach ($downtimehistory as $downtimehistory_row) { */



foreach ($externalcommands as $externalcommands_row) {
	$ec_test = 1;
	# Determine if this command is for this host
	$externalcommand_host_explode = explode(';',  $externalcommands_row['command_args']);
	//print_r('$externalcommand_host_explode[0]: ' . $externalcommand_host_explode[0] . "<br/><br/><br/>");
	if ($currentobject_name1 == $externalcommand_host_explode[0]) {
		//print_r('$externalcommand_host_explode[0]: ' . $externalcommand_host_explode[0] . "<br/><br/><br/>");
		if ($currentobject_name2 == '') {
			if (!isset($externalcommand_host_explode[1])) {
				$ec_test = 2;
				} /* End if (!isset($externalcommand_host_explode[1])) { */
			} /* End if ($currentobject_name2 == '') { */
		else {
			if (isset($externalcommand_host_explode[1])) {
				if ($currentobject_name2 == $externalcommand_host_explode[1]) {
					$ec_test = 2;
					} /* End if ($currentobject_name2 == $externalcommand_host_explode[1]) { */
				} /* End if (!isset($externalcommand_host_explode[1])) { */
			} /* End else { */
		} /* End if ($currentobject_name1 == $externalcommand_host_explode[0]) { */
	
	if ($ec_test == 2) {
		switch ($externalcommands_row['command_name']) {
			case 'DISABLE_HOST_EVENT_HANDLER':
				$externalcommand_comment_data = 'Host event handler disabled';
				break; /* End case 'DISABLE_HOST_EVENT_HANDLER': */
			

			case 'DISABLE_SVC_EVENT_HANDLER':
				$externalcommand_comment_data = 'Service event handler disabled';
				break; /* End case 'DISABLE_SVC_EVENT_HANDLER': */
			

			case 'ENABLE_HOST_EVENT_HANDLER':
				$externalcommand_comment_data = 'Host event handler enabled';
				break; /* End case 'ENABLE_HOST_EVENT_HANDLER': */
			

			case 'ENABLE_SVC_EVENT_HANDLER':
				$externalcommand_comment_data = 'Service event handler enabled';
				break; /* End case 'ENABLE_SVC_EVENT_HANDLER': */
			

			case 'DISABLE_HOST_FLAP_DETECTION':
				$externalcommand_comment_data = 'Host flap detection disabled';
				break; /* End case 'DISABLE_HOST_FLAP_DETECTION': */
			

			case 'DISABLE_SVC_FLAP_DETECTION':
				$externalcommand_comment_data = 'Service flap detection disabled';
				break; /* End case 'DISABLE_SVC_FLAP_DETECTION': */
			

			case 'ENABLE_HOST_FLAP_DETECTION':
				$externalcommand_comment_data = 'Host flap detection enabled';
				break; /* End case 'ENABLE_HOST_FLAP_DETECTION': */
			

			case 'ENABLE_SVC_FLAP_DETECTION':
				$externalcommand_comment_data = 'Service flap detection enabled';
				break; /* End case 'ENABLE_SVC_FLAP_DETECTION': */
			

			case 'DISABLE_HOST_CHECK':
				$externalcommand_comment_data = 'Active host checks disabled';
				break; /* End case 'DISABLE_HOST_CHECK': */
			

			case 'DISABLE_SVC_CHECK':
				$externalcommand_comment_data = 'Active service checks disabled';
				break; /* End case 'DISABLE_SVC_CHECK': */


			case 'ENABLE_HOST_CHECK':
				$externalcommand_comment_data = 'Active host checks enabled';
				break; /* End case 'ENABLE_HOST_CHECK': */
			

			case 'ENABLE_SVC_CHECK':
				$externalcommand_comment_data = 'Active service checks enabled';
				break; /* End case 'ENABLE_SVC_CHECK': */


			case 'DISABLE_HOST_NOTIFICATIONS':
				$externalcommand_comment_data = 'Host notifications disabled';
				break; /* End case 'DISABLE_HOST_NOTIFICATIONS': */
			

			case 'DISABLE_SVC_NOTIFICATIONS':
				$externalcommand_comment_data = 'Service notifications disabled';
				break; /* End case 'DISABLE_SVC_NOTIFICATIONS': */


			case 'ENABLE_HOST_NOTIFICATIONS':
				$externalcommand_comment_data = 'Host notifications enabled';
				break; /* End case 'DISABLE_HOST_NOTIFICATIONS': */
			

			case 'ENABLE_SVC_NOTIFICATIONS':
				$externalcommand_comment_data = 'Service notifications enabled';
				break; /* End case 'DISABLE_SVC_NOTIFICATIONS': */


			case 'DISABLE_PASSIVE_HOST_CHECKS':
				$externalcommand_comment_data = 'Passive host checks disabled';
				break; /* End case 'DISABLE_PASSIVE_HOST_CHECKS': */


			case 'DISABLE_PASSIVE_SVC_CHECKS':
				$externalcommand_comment_data = 'Passive service checks disabled';
				break; /* End case 'DISABLE_PASSIVE_SVC_CHECKS': */


			case 'ENABLE_PASSIVE_HOST_CHECKS':
				$externalcommand_comment_data = 'Passive host checks enabled';
				break; /* End case 'ENABLE_PASSIVE_HOST_CHECKS': */


			case 'ENABLE_PASSIVE_SVC_CHECKS':
				$externalcommand_comment_data = 'Passive service checks enabled';
				break; /* End case 'ENABLE_PASSIVE_SVC_CHECKS': */


			case 'START_OBSESSING_OVER_HOST':
				$externalcommand_comment_data = 'Host obsession enabled';
				break; /* End case 'START_OBSESSING_OVER_HOST': */


			case 'START_OBSESSING_OVER_SVC':
				$externalcommand_comment_data = 'Service obsession enabled';
				break; /* End case 'START_OBSESSING_OVER_SVC': */


			case 'STOP_OBSESSING_OVER_HOST':
				$externalcommand_comment_data = 'Host obsession disabled';
				break; /* End case 'STOP_OBSESSING_OVER_HOST': */


			case 'STOP_OBSESSING_OVER_SVC':
				$externalcommand_comment_data = 'Service obsession disabled';
				break; /* End case 'STOP_OBSESSING_OVER_SVC': */
			} /* End switch ($externalcommands_row['command_name']) { */
			
		
		$history_array[] = array(
			'commenthistory_id'	=> $externalcommands_row['externalcommand_id'],
			'entry_time' 		=> $externalcommands_row['entry_time'],
			'comment_data' 		=> $externalcommand_comment_data,
			'author_name' 		=> 'Authorized User',
			'type' 				=> 'External Command',
			); /* End $history_array[] = array( */
		} /* End if ($ec_test == 2) { */
	} /* End foreach ($externalcommands as $externalcommands_row) { */


//print_r("<br>history array<br>");	
//print_r($history_array);
//print_r("<br><br>");	


/* Sort the History array */
usort($history_array, 'historytab_cmp'); 
	
/* Detect any history */	
$current_item = 0;
if (empty($history_array)) {
	$html .= 'No history found';
	} /* End if (empty($history_array)) { */
else {
	/* Build the table */
	$html .= '
		<table><tr><td>
	
			<table class="standardtable servicestatustable">
				<tr><th>Date / Time</th><th>Type</th><th>Data</th><th>Author</th><th>State</th></tr>
		';

	foreach ($history_array as $i => $value) {
		/* Checking to make sure we are not displaying more than $number_items */
		if ($i < $number_items) {
			$current_item++;
			if(($current_item%2)==0) {
				$rowclass = 'even';
				} /* End if(($current_item%2)==0) { */
			else {
				$rowclass = 'odd';
				} /* End else { */
			$html .= '
					<tr class='.$rowclass.'>
						<td>'.$history_array[$i]['entry_time'].'</td>
						<td>'.$history_array[$i]['type'].'</td>
						<td>'.$history_array[$i]['comment_data'].'</td>
						<td>'.$history_array[$i]['author_name'].'</td>
				';

			switch ($history_array[$i]['type']) {
				case 'Acknowledgement':
					$html .= historytab_td_states_services($history_array[$i]['state']);
					break; /* End case 'Acknowledgement': */
				

				case 'Comment':
					$html .= '<td>N/A</td>';
					break; /* End case 'Comment': */

				
				case 'Comment History':
					$html .= '<td>N/A</td>';
					break; /* End case: 'Comment History': */


				case 'External Command':
					$html .= '<td>N/A</td>';
					break; /* End case 'External Command': */

				
				case 'Scheduled Downtime Comment':
					$html .= '<td>N/A</td>';
					break; /* End case: 'Scheduled Downtime Comment': */


				case 'Scheduled Downtime Comment History':
					$html .= '<td>N/A</td>';
					break; /* End case: 'Scheduled Downtime Comment History': */

				} /* End switch ($history_array[$i]['type']) { */
			} /* End if ($i < $number_items) { */
		} /* End foreach ($history_array as $i => $value) { */

	$html .= '
					</tr>
				</table>
			</td></tr>

			<tr><td><div class="historytab-spacer10"> </div></td></tr>

			<tr><td class="historytab-align-center">
				Limit results by: 
				<select name="historytab_number_items_select" id="id_historytab_number_items_select" onChange="historytab_load_table()">
					<option value="25"'; if ($number_items == '25') $html .= ' selected'; $html .= '>25</option>
					<option value="50"'; if ($number_items == '50') $html .= ' selected'; $html .= '>50</option>
					<option value="100"'; if ($number_items == '100') $html .= ' selected'; $html .= '>100</option>
					<option value="250"'; if ($number_items == '250') $html .= ' selected'; $html .= '>250</option>
					<option value="500"'; if ($number_items == '500') $html .= ' selected'; $html .= '>500</option>
				</select>
			</td></tr>
		</table>
			';

	} /* End else { */


print $html;


/* This is for sorting the history_array */
/* comparison function */
//$a, $b = Oldest to Newest
//$b, $a = Newest to Oldest
function historytab_cmp ($b, $a) {
	return strcmp($a['entry_time'], $b['entry_time']); 
	} /* End function historytab_cmp ($b, $a) { */


function historytab_td_states_services($a) {
	switch ($a) {
		case '0':
			$td = '<td class="serviceok">OK</td>';
			break; /* End case '0': */


		case '1':
			$td = '<td class="servicewarning">Warning</td>';
			break; /* End case '1': */


		case '2':
			$td = '<td class="servicecritical">Critical</td>';
			break; /* End case '2': */


		case '3':
			$td = '<td class="serviceunknown">Unknown</td>';
			break; /* End case '3': */


		default:
			$td = '<td></td>';
			break; /* End default: */

		} /* End switch ($a) { */
	return $td;
	} /* End function historytab_td_states_services($a) { */


?>
